<?

    /**
     * Graphite
     *
     * Copyright 2005 Scott Reynen
     *
     * This program is free software; you can redistribute it and/or modify
     * it under the terms of the GNU General Public License as published by
     * the Free Software Foundation; either version 2 of the License, or
     * (at your option) any later version.
     * 
     * This program is distributed in the hope that it will be useful,
     * but WITHOUT ANY WARRANTY; without even the implied warranty of
     * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     * GNU General Public License for more details: 
     * <http: *www.gnu.org/licenses/gpl.txt>
     */

	function get_current_number( $url , $pre_text , $post_text ) {
		
		$content = @file_get_contents( $url );
		
		if ( $content === FALSE ) die( '! URL' );
		$content = preg_replace( "#\s+#" , ' ' , $content );
		$pre_position = strpos( $content , $pre_text );
		if ( $pre_position === FALSE ) die( '! Pre' );
		$end_of_pre_text = $pre_position + strlen( $pre_text );
		$post_position = strpos( $content , $post_text , $end_of_pre_text );
		if ( $post_position === FALSE ) die( '! Post' );
		$result_length = $post_position - $end_of_pre_text;
		$result = trim( substr( $content , $end_of_pre_text , $result_length ) );
		$result = preg_replace( '/[^\d\.]/' , '' , $result );
		return ( strlen( $result ) == 0 ) ? 0 : $result;
		
	} // get_current_number

	

	$url = $argv[1];
	$pre_text = preg_replace( "#\s+#" , ' ' , $argv[2] );
	$post_text = preg_replace( "#\s+#" , ' ' , $argv[3] );
	$frequency = $argv[4];
	$user_name = $argv[5];
	
	$file_name = sha1( $url . $pre_text . $post_text );
	$file_location = '/Users/' . $user_name;
	$file_location.= '/LIbrary/Application Support/Graphite/';
		
	$file_location.= $file_name . '.txt';
	$lines = ( file_exists( $file_location ) ) ?
		file( $file_location ) : array();
	$time_lapsed = TRUE;
		
	if ( count( $lines ) > 0 ) {
		$parts = explode( ' ' , $lines[0] );
		$time = substr( $parts[0] , 0 , 8 ) . ' ';
		$time.= substr( $parts[0] , 8 , 2 ) . ':';
		$time.= substr( $parts[0] , 10 , 2 ) . ':';
		$time.= substr( $parts[0] , 12 , 2 );
		$time.= ( $frequency == 'hourly' ) ? ' + 1 hour' : ' + 1 day';
		if ( time() < strtotime( $time ) ) $time_lapsed = FALSE;
	} // if
	if ( $time_lapsed ) {
		$current_number = get_current_number( $url , $pre_text , $post_text );
		$new_line = date( 'YmdHis' , time() ) . ' ' . $current_number;
		if ( count( $lines ) > 0 ) $new_line.= "\n";
		array_unshift( $lines , $new_line );
		if ( count( $lines ) > 150 ) array_pop( $lines );
		$file_content = implode( '' , $lines );
		$file_handle = fopen( $file_location , 'w' );
		fwrite( $file_handle , $file_content );
		fclose( $file_handle );
	} else $file_content = implode( '' , $lines );
	die( $file_content );
	
?>